class PluginPuppetBaselineAddBaselineResourceDigestToBaselineDifferences < ActiveRecord::Migration
  def self.up
    add_column :baseline_differences, :baseline_resource_digest, 'CHAR(24)'
    add_index  :baseline_differences, :baseline_resource_digest

    diffs = BaselineDifference.find(:all, :conditions => "baseline_resource_id IS NOT NULL")
    if diffs.count > 0 then
      STDOUT.puts "-- calculating baseline difference resource status digests"
      pbar = ProgressBar.new("   ->", diffs.count)

      ids    = diffs.collect {|x| x.baseline_resource_id }
      hashes = Summarizer.calculate_some_baseline_property_hashes_quickly(ids)

      diffs.each do |diff|
        digest = hashes[diff.baseline_resource_id.to_s]
        where = [:node_baseline_id, :resource_name, :report_resource_id, :baseline_resource_id].
          map {|key| v = diff.send key ; "#{key} #{v.nil? ? 'IS NULL' : "= #{ActiveRecord::Base.connection.quote(v)}"}" }.
          join(" AND ")
        BaselineDifference.update_all("baseline_resource_digest = '#{digest}'", where)
        pbar.inc
      end
      pbar.finish
    end
  end

  def self.down
    remove_index  :baseline_differences, :baseline_resource_digest
    remove_column :baseline_differences, :baseline_resource_digest
  end
end
